#include <iostream>
#include "MersenneTwister.h"
using namespace std;

MTRand rand1;
const int monte_carlo_steps = 20000;
double blairsFerry()
{
	//3.6 miles @ 35 mph; 8 lights: 50% chance per hitting; 2 min. delay/light
	double lightSpacing = (3.6/8);
	double speed = (35.0/60); //Miles per minute
	double timeBtwLight = lightSpacing / speed; //Minutes btw. lights
	
	double timeElapsed = 0; //In minutes
	int lightsPassed = 0;
	while(lightsPassed < 8)
	{
		timeElapsed += timeBtwLight;
		double rand = rand1.rand(1);
		if(rand < 0.5) //Light is hit
			timeElapsed+=2;
	
		lightsPassed++;
	}
			
	return timeElapsed;	
}
double collins()
{
	double lightSpacing = (2.2/7);
	double speed = (25.0/60);
	double timeBtwLight = lightSpacing/speed;
	double timeElapsed = 0;
	int lightsPassed = 0;

	timeElapsed += 0.7/speed; //Initial, lightless section
	while(lightsPassed < 7)
	{
		timeElapsed += timeBtwLight;
		double rand = rand1.rand(1);
		if(rand < 0.35) //Light is hit
			timeElapsed+=3;

		lightsPassed++;
	}
	return timeElapsed;
}
double monteCarlo(char q)
{
	double results = 0;
	switch(q)
	{
	case 'c': for(int i = 0; i < monte_carlo_steps; i++)
			  {
				  results += collins();
			  }
			  results/=monte_carlo_steps;
			  return results;
	 
	case 'b': for(int i = 0; i < monte_carlo_steps; i++)
			  {
				  results += blairsFerry();
			  }
			  results/=monte_carlo_steps;
			  return results;

	default: return 0;
	}
}
int main()
{
	double collins = monteCarlo('c');
	double blairs = monteCarlo('b');
	cout << "Collins Results: " << collins << endl;
	cout << "Collins ERROR: " << collins-14.31 << "(" << abs(((collins-14.31)/collins))*100 << "%)" << endl;
	cout << "Blair's Ferry Results: " << blairs << endl;
	cout << "Blair's Ferry ERROR: " << blairs-14.17 << "(" << abs(((blairs-14.17)/blairs)*100) << "%)" << endl;
	system("PAUSE");
	return 0;
}